+2014-07-08 Cary Coutant <ccoutant@google.com>
+
+ * expression.cc (struct Expression::Expression_eval_info): Add
+ new fields type_pointer, vis_pointer, and nonvis_pointer.
+ (Expression::eval_maybe_dot): Add type_pointer, vis_pointer, and
+ nonvis_pointer parameters. Adjust all calls.
+ (Symbol_expression::value): Update type, visibility, and nonvis bits
+ in caller.
+ * script.cc (Symbol_assignment::sized_finalize): Update type,
+ visibility, and remaining st_other bits for new symbol.
+ * script.h: (Expression::eval_maybe_dot): Add type_pointer,
+ vis_pointer, and nonvis_pointer parameters.
+ * symtab.h (Symbol::set_type): New method.
+
+ * testsuite/Makefile.am (defsym_test): New test.
+ * testsuite/Makefile.in: Regenerate.
+ * testsuite/defsym_test.c: New file.
+ * testsuite/defsym_test.sh: New file.
+
2014-07-08 Cary Coutant <ccoutant@google.com>
PR gold/15639
Output_section** result_section_pointer;
// Pointer to where the alignment of the result should be stored.
uint64_t* result_alignment_pointer;
+ // Pointer to where the type of the symbol on the RHS should be stored.
+ elfcpp::STT* type_pointer;
+ // Pointer to where the visibility of the symbol on the RHS should be stored.
+ elfcpp::STV* vis_pointer;
+ // Pointer to where the rest of the symbol's st_other field should be stored.
+ unsigned char* nonvis_pointer;
};
// Evaluate an expression.
Expression::eval(const Symbol_table* symtab, const Layout* layout,
bool check_assertions)
{
- return this->eval_maybe_dot(symtab, layout, check_assertions,
- false, 0, NULL, NULL, NULL, false);
+ return this->eval_maybe_dot(symtab, layout, check_assertions, false, 0,
+ NULL, NULL, NULL, NULL, NULL, NULL, false);
}
// Evaluate an expression which may refer to the dot symbol.
{
return this->eval_maybe_dot(symtab, layout, check_assertions, true,
dot_value, dot_section, result_section_pointer,
- result_alignment_pointer,
+ result_alignment_pointer, NULL, NULL, NULL,
is_section_dot_assignment);
}
uint64_t dot_value, Output_section* dot_section,
Output_section** result_section_pointer,
uint64_t* result_alignment_pointer,
+ elfcpp::STT* type_pointer,
+ elfcpp::STV* vis_pointer,
+ unsigned char* nonvis_pointer,
bool is_section_dot_assignment)
{
Expression_eval_info eei;
*result_section_pointer = NULL;
eei.result_section_pointer = result_section_pointer;
+ // For symbol=symbol assignments, we need to track the type, visibility,
+ // and remaining st_other bits.
+ eei.type_pointer = type_pointer;
+ eei.vis_pointer = vis_pointer;
+ eei.nonvis_pointer = nonvis_pointer;
+
eei.result_alignment_pointer = result_alignment_pointer;
uint64_t val = this->value(&eei);
if (eei->result_section_pointer != NULL)
*eei->result_section_pointer = sym->output_section();
+ if (eei->type_pointer != NULL)
+ *eei->type_pointer = sym->type();
+ if (eei->vis_pointer != NULL)
+ *eei->vis_pointer = sym->visibility();
+ if (eei->nonvis_pointer != NULL)
+ *eei->nonvis_pointer = sym->nonvis();
if (parameters->target().get_size() == 32)
return eei->symtab->get_sized_symbol<32>(sym)->value();
eei->dot_section,
arg_section_pointer,
eei->result_alignment_pointer,
+ NULL,
+ NULL,
+ NULL,
false);
}
eei->dot_section,
section_pointer,
alignment_pointer,
+ NULL,
+ NULL,
+ NULL,
false);
}
eei->dot_section,
section_pointer,
alignment_pointer,
+ NULL,
+ NULL,
+ NULL,
false);
}
eei->dot_section,
section_pointer,
NULL,
+ NULL,
+ NULL,
+ NULL,
false);
}
eei->dot_section,
section_pointer,
alignment_pointer,
+ NULL,
+ NULL,
+ NULL,
false);
}
eei->dot_section,
section_pointer,
alignment_pointer,
+ NULL,
+ NULL,
+ NULL,
false);
}
Output_section* dot_section)
{
Output_section* section;
+ elfcpp::STT type = elfcpp::STT_NOTYPE;
+ elfcpp::STV vis = elfcpp::STV_DEFAULT;
+ unsigned char nonvis = 0;
uint64_t final_val = this->val_->eval_maybe_dot(symtab, layout, true,
is_dot_available,
dot_value, dot_section,
- §ion, NULL, false);
+ §ion, NULL, &type,
+ &vis, &nonvis, false);
Sized_symbol<size>* ssym = symtab->get_sized_symbol<size>(this->sym_);
ssym->set_value(final_val);
+ ssym->set_type(type);
+ ssym->set_visibility(vis);
+ ssym->set_nonvis(nonvis);
if (section != NULL)
ssym->set_output_section(section);
}
uint64_t val = this->val_->eval_maybe_dot(symtab, layout, false,
is_dot_available, dot_value,
dot_section, &val_section, NULL,
- false);
+ NULL, NULL, NULL, false);
if (val_section != NULL && val_section != dot_section)
return;
#include <string>
#include <vector>
+#include "elfcpp.h"
#include "script-sections.h"
namespace gold
bool is_dot_available, uint64_t dot_value,
Output_section* dot_section,
Output_section** result_section, uint64_t* result_alignment,
+ elfcpp::STT* type, elfcpp::STV* vis, unsigned char* nonvis,
bool is_section_dot_assignment);
// Print the expression to the FILE. This is for debugging.
type() const
{ return this->type_; }
+ // Set the symbol type.
+ void
+ set_type(elfcpp::STT type)
+ { this->type_ = type; }
+
// Return true for function symbol.
bool
is_func() const
ehdr_start_test_5_LDFLAGS = -Bgcctestdir/
ehdr_start_test_5_LDADD =
+# Test that the --defsym option copies the symbol type and visibility.
+check_SCRIPTS += defsym_test.sh
+check_DATA += defsym_test.syms
+MOSTLYCLEANFILES += defsym_test.syms
+defsym_test.syms: defsym_test
+ $(TEST_READELF) -sW $< > $@
+defsym_test: defsym_test.o gcctestdir/ld
+ $(LINK) -Bgcctestdir/ -Wl,--defsym=bar=foo defsym_test.o
+defsym_test.o: defsym_test.c
+ $(COMPILE) -c -o $@ $<
+
# End-to-end incremental linking tests.
# Incremental linking is currently supported only on the x86_64 target.
# Test that __ehdr_start is left undefined when the text segment is not
# appropriately aligned.
-@GCC_TRUE@@NATIVE_LINKER_TRUE@am__append_70 = ehdr_start_test_4.sh
-@GCC_TRUE@@NATIVE_LINKER_TRUE@am__append_71 = ehdr_start_test_4.syms
-@GCC_TRUE@@NATIVE_LINKER_TRUE@am__append_72 = ehdr_start_test_4
+
+# Test that the --defsym option copies the symbol type and visibility.
+@GCC_TRUE@@NATIVE_LINKER_TRUE@am__append_70 = ehdr_start_test_4.sh \
+@GCC_TRUE@@NATIVE_LINKER_TRUE@ defsym_test.sh
+@GCC_TRUE@@NATIVE_LINKER_TRUE@am__append_71 = ehdr_start_test_4.syms \
+@GCC_TRUE@@NATIVE_LINKER_TRUE@ defsym_test.syms
+@GCC_TRUE@@NATIVE_LINKER_TRUE@am__append_72 = ehdr_start_test_4 \
+@GCC_TRUE@@NATIVE_LINKER_TRUE@ defsym_test.syms
@GCC_FALSE@ehdr_start_test_5_DEPENDENCIES =
@NATIVE_LINKER_FALSE@ehdr_start_test_5_DEPENDENCIES =
@p='gdb_index_test_4.sh'; $(am__check_pre) $(LOG_COMPILE) "$$tst" $(am__check_post)
ehdr_start_test_4.sh.log: ehdr_start_test_4.sh
@p='ehdr_start_test_4.sh'; $(am__check_pre) $(LOG_COMPILE) "$$tst" $(am__check_post)
+defsym_test.sh.log: defsym_test.sh
+ @p='defsym_test.sh'; $(am__check_pre) $(LOG_COMPILE) "$$tst" $(am__check_post)
script_test_10.sh.log: script_test_10.sh
@p='script_test_10.sh'; $(am__check_pre) $(LOG_COMPILE) "$$tst" $(am__check_post)
split_i386.sh.log: split_i386.sh
@GCC_TRUE@@NATIVE_LINKER_TRUE@ $(CXXLINK) -Bgcctestdir/ -Wl,-Ttext=0x100100 $<
@GCC_TRUE@@NATIVE_LINKER_TRUE@ehdr_start_test_4.o: ehdr_start_test.cc
@GCC_TRUE@@NATIVE_LINKER_TRUE@ $(CXXCOMPILE) -c -DEHDR_START_WEAK -o $@ $<
+@GCC_TRUE@@NATIVE_LINKER_TRUE@defsym_test.syms: defsym_test
+@GCC_TRUE@@NATIVE_LINKER_TRUE@ $(TEST_READELF) -sW $< > $@
+@GCC_TRUE@@NATIVE_LINKER_TRUE@defsym_test: defsym_test.o gcctestdir/ld
+@GCC_TRUE@@NATIVE_LINKER_TRUE@ $(LINK) -Bgcctestdir/ -Wl,--defsym=bar=foo defsym_test.o
+@GCC_TRUE@@NATIVE_LINKER_TRUE@defsym_test.o: defsym_test.c
+@GCC_TRUE@@NATIVE_LINKER_TRUE@ $(COMPILE) -c -o $@ $<
# End-to-end incremental linking tests.
# Incremental linking is currently supported only on the x86_64 target.
--- /dev/null
+#include <stdio.h>
+
+void foo (void) __attribute__ ((noinline, visibility ("hidden")));
+
+void foo (void) {
+ printf("foo called.\n");
+}
+
+void bar(void);
+
+int main(void) {
+ foo();
+ bar();
+ return 0;
+}
--- /dev/null
+#!/bin/sh
+
+# defsym_test.sh -- test that --defsym copies type and visiblity.
+
+# Copyright (C) 2014 Free Software Foundation, Inc.
+# Written by Cary Coutant <ccoutant@google.com>.
+
+# This file is part of gold.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
+# MA 02110-1301, USA.
+
+check()
+{
+ if ! grep -q "$2" "$1"
+ then
+ echo "Did not find expected symbol in $1:"
+ echo " $2"
+ echo ""
+ echo "Actual output below:"
+ cat "$1"
+ exit 1
+ fi
+}
+
+check defsym_test.syms "FUNC *GLOBAL *HIDDEN *[0-9]* *bar"
+
+exit 0